# from parallel:::clusterSetRNGStream(GPL-2)
Rhpc_setupRNG <- function(cl = NULL, iseed = NULL)
{
    oldseed <-
        if (exists(".Random.seed", envir = .GlobalEnv, inherits = FALSE))
            get(".Random.seed", envir = .GlobalEnv, inherits = FALSE)
        else NULL
    RNGkind("L'Ecuyer-CMRG")
    if(!is.null(iseed)) set.seed(iseed)
    nc <- Rhpc_numberOfWorker(cl)
    seeds <- vector("list", nc)
    seeds[[1L]] <- .Random.seed
    for(i in seq_len(nc-1L)) seeds[[i+1L]] <- nextRNGStream(seeds[[i]])
    ## Reset the random seed in the master.
    if(!is.null(oldseed))
        assign(".Random.seed", oldseed, envir = .GlobalEnv)
    else rm(.Random.seed, envir = .GlobalEnv)
    Rhpc_lapply(cl, seeds, function(seed) assign(".Random.seed", seed, envir = .GlobalEnv))
    invisible()
}


#from snow:::clusterSetupRNGstream(GPL)
#Rhpc_setupRNG <- function (cl,seed=rep(12345,6),...){
#    .lec.init()
#    .lec.SetPackageSeed(seed)
#    nc <- Rhpc_numberOfWorker(cl)
#    names <- as.character(1:nc)
#    .lec.CreateStream(names)
#    states <- lapply(names, .lec.GetStateList)
#    invisible(Rhpc_lapply(cl, states, Rhpc_initRNGworker))
#}

#Rhpc_initRNGworker <- function (stream) {
#
#    if (length(.lec.Random.seed.table$name) > 0) {
#        rm(".lec.Random.seed.table", envir=.GlobalEnv)
#        assign(".lec.Random.seed.table", list(Cg=matrix(0,nrow=0,ncol=6),
#                                              Bg=matrix(0,nrow=0,ncol=6),
#                                              Ig=matrix(0,nrow=0,ncol=6),
#                                              AIP=matrix(0,nrow=0,ncol=2),
#                                              name=c()), envir=.GlobalEnv)
#    }
#    .lec.Random.seed.table$Cg <<- rbind(.lec.Random.seed.table$Cg,
#                                        stream$Cg[1:6])
#    .lec.Random.seed.table$Bg <<- rbind(.lec.Random.seed.table$Bg,stream$Bg)
#    .lec.Random.seed.table$Ig <<- rbind(.lec.Random.seed.table$Ig,stream$Ig)
#    .lec.Random.seed.table$AIP <<- rbind(.lec.Random.seed.table$AIP,
#                                         c(stream$Anti, stream$IncPrec))
#    .lec.Random.seed.table$name <<- c(.lec.Random.seed.table$name, stream$name)
#
#    old.kind<-.lec.CurrentStream(stream$name)
#    old.kind
#}

